package demo;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import javax.swing.WindowConstants;
import javax.swing.SwingUtilities;

import extVisitor.*;



/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
public class DemoFrame extends javax.swing.JFrame {
	/**
	 * 
	 */
	private static final long serialVersionUID = 2217461607762561446L;
	private JScrollPane outputSPane;
	private JPanel cmdPnl;
	private JTextField visitorIDTF;
	private JButton executeBtn;
	private JButton makeVisitorBtn;
	private JComboBox visitorCBx;
	private JPanel visitorPnl;
	private JComboBox hostCBx;
	private JButton makeHostBtn;
	private JPanel hostPnl;
	private JTextField idTF;
	private JLabel idLbl;
	private JTextField cmdTF;
	private JButton makeCmdBtn;
	private JPanel idPnl;
	private JPanel controlPnl;
	private JTextArea outputTA;

	/**
	* Auto-generated main method to display this JFrame
	*/
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				DemoFrame inst = new DemoFrame();
				inst.setLocationRelativeTo(null);
				inst.setVisible(true);
			}
		});
	}
	
	public DemoFrame() {
		super();
		initGUI();
	}
	
	private void initGUI() {
		try {
			setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
			{
				outputSPane = new JScrollPane();
				getContentPane().add(outputSPane, BorderLayout.CENTER);
				{
					outputTA = new JTextArea();
					outputSPane.setViewportView(outputTA);
					outputTA.setToolTipText("The output of executing the visitors is shown here.");
				}
			}
			{
				controlPnl = new JPanel();
				getContentPane().add(controlPnl, BorderLayout.NORTH);
				controlPnl.setPreferredSize(new java.awt.Dimension(670, 106));
				{
					idPnl = new JPanel();
					controlPnl.add(idPnl);
					idPnl.setBorder(BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(0,0,0)));
					idPnl.setBackground(new java.awt.Color(128,255,255));
					idPnl.setPreferredSize(new java.awt.Dimension(96, 35));
					{
						idLbl = new JLabel();
						idPnl.add(idLbl);
						idLbl.setText("ID = ");
						idLbl.setToolTipText("ID for host or command");
					}
					{
						idTF = new JTextField();
						idPnl.add(idTF);
						idTF.setText("A");
						idTF.setPreferredSize(new java.awt.Dimension(59, 23));
						idTF.setToolTipText("Type ID value here");
					}
				}
				{
					hostPnl = new JPanel();
					GridLayout hostPnlLayout = new GridLayout(2, 1);
					hostPnlLayout.setColumns(1);
					hostPnlLayout.setHgap(5);
					hostPnlLayout.setVgap(5);
					hostPnlLayout.setRows(2);
					hostPnl.setLayout(hostPnlLayout);
					controlPnl.add(hostPnl);
					hostPnl.setBorder(BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(0,0,0)));
					hostPnl.setPreferredSize(new java.awt.Dimension(117, 53));
					{
						makeHostBtn = new JButton();
						hostPnl.add(makeHostBtn);
						makeHostBtn.setText("Make Host");
						makeHostBtn.setToolTipText("Make a new host with the given ID");
						makeHostBtn.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent evt) {
								System.out.println("makeHostBtn.actionPerformed, event="+evt);
								final String id = idTF.getText();
								hostCBx.addItem(new IHost(){

									@Override
									public Object execute(IExtVisitor algo, Object... params) {
										return algo.caseAt(id, this, params);
									}
									
									public String toString() {
										return "Host_"+id;
									}
								});
								hostCBx.setSelectedIndex(hostCBx.getItemCount()-1);
							}
						});
					}
					{
						hostCBx = new JComboBox();
						hostPnl.add(hostCBx);
						hostCBx.setPreferredSize(new java.awt.Dimension(73, 23));
						hostCBx.setOpaque(false);
						hostCBx.setToolTipText("All available hosts");
					}
				}
				{
					executeBtn = new JButton();
					controlPnl.add(executeBtn);
					executeBtn.setText("Execute!");
					executeBtn.setBackground(new java.awt.Color(255,0,0));
					executeBtn.setToolTipText("Executet the given extended visitor on te given host.");
					executeBtn.addActionListener(new ActionListener() {
						public void actionPerformed(ActionEvent evt) {
							System.out.println("executeBtn.actionPerformed, event="+evt);
							IHost host = (IHost)hostCBx.getSelectedItem();
							IExtVisitor algo = (IExtVisitor) visitorCBx.getSelectedItem();
							Object result = host.execute(algo);
							outputTA.append(host+".execute("+algo+") ==> "+result+"\n");
						}
					});
				}
				{
					visitorPnl = new JPanel();
					controlPnl.add(visitorPnl);
					GridLayout jPanel1Layout = new GridLayout(3, 1);
					jPanel1Layout.setColumns(1);
					jPanel1Layout.setRows(3);
					jPanel1Layout.setHgap(5);
					jPanel1Layout.setVgap(5);
					visitorPnl.setBorder(BorderFactory.createMatteBorder(1,1,1,1,new java.awt.Color(0,0,0)));
					visitorPnl.setLayout(jPanel1Layout);
					visitorPnl.setPreferredSize(new java.awt.Dimension(188, 94));
					{
						makeVisitorBtn = new JButton();
						visitorPnl.add(makeVisitorBtn);
						makeVisitorBtn.setText("Make Visitor with name:");
						makeVisitorBtn.setSelected(true);
						makeVisitorBtn.setToolTipText("Make a new visitor with the given name.");
						makeVisitorBtn.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent evt) {
								System.out.println("makeVisitorBtn.actionPerformed, event="+evt);
								visitorCBx.addItem(new ExtVisitor(visitorIDTF.getText()));
								visitorCBx.setSelectedIndex(visitorCBx.getItemCount()-1);
							}
						});
					}
					{
						visitorIDTF = new JTextField();
						visitorPnl.add(visitorIDTF);
						visitorIDTF.setText("1");
						visitorIDTF.setToolTipText("Type an identifying name for the visitor");
					}
					{
						ComboBoxModel jComboBox1Model = 
							new DefaultComboBoxModel();
						visitorCBx = new JComboBox();
						visitorPnl.add(visitorCBx);
						visitorCBx.setModel(jComboBox1Model);
						visitorCBx.setPreferredSize(new java.awt.Dimension(73,23));
						visitorCBx.setOpaque(false);
						visitorCBx.setToolTipText("The available visitors");
					}
				}
				{
					cmdPnl = new JPanel();
					GridLayout cmdPnlLayout = new GridLayout(2, 1);
					cmdPnlLayout.setColumns(1);
					cmdPnlLayout.setHgap(5);
					cmdPnlLayout.setVgap(5);
					cmdPnlLayout.setRows(2);
					cmdPnl.setLayout(cmdPnlLayout);
					controlPnl.add(cmdPnl);
					cmdPnl.setBorder(BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(0,0,0)));
					{
						makeCmdBtn = new JButton();
						cmdPnl.add(makeCmdBtn);
						makeCmdBtn.setText("Make Cmd for Visitor for ID");
						makeCmdBtn.setToolTipText("Make a new command for the selected visitor that will service hosts with the given ID.");
						makeCmdBtn.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent evt) {
								System.out.println("makeCmdBtn.actionPerformed, event="+evt);
								ExtVisitor algo = (ExtVisitor) visitorCBx.getSelectedItem();
								final String resultStr = cmdTF.getText();
								algo.addCmd(idTF.getText(), new IExtVisitorCmd(){

									@Override
									public Object apply(String id, IHost host, Object... params) {
										return "cmds["+id+"] --> "+ resultStr;
									}
									
								});

							}
						});
					}
					{
						cmdTF = new JTextField();
						cmdPnl.add(cmdTF);
						cmdTF.setText("Do something");
						cmdTF.setToolTipText("Type some sort of output for this command");
					}
				}
			}
			pack();
			this.setSize(757, 300);
		} catch (Exception e) {
		    //add your error handling code here
			e.printStackTrace();
		}
	}

}
